Subject: Re: Bluetooth: Prevent stack info leak from the EFS element.

From: "[email-masked]" <[email-masked]>
Date: Thu, 4 Jan 2018 16:58:37 +0100

On Tue, Jan 02, 2018 at 12:26:15PM -0800, Guenter Roeck wrote:
> On Fri, Dec 08, 2017 at 03:14:47PM +0100, [email-masked] wrote:
> > From: Ben Seri <[email-masked]>
> > 
> > In the function l2cap_parse_conf_rsp and in the function
> > l2cap_parse_conf_req the following variable is declared without
> > initialization:
> > 
> > struct l2cap_conf_efs efs;
> > 
> > In addition, when parsing input configuration parameters in both of
> > these functions, the switch case for handling EFS elements may skip the
> > memcpy call that will write to the efs variable:
> > 
> > ...
> > case L2CAP_CONF_EFS:
> > if (olen == sizeof(efs))
> > memcpy(&efs, (void *)val, olen);
> > ...
> > 
> > The olen in the above if is attacker controlled, and regardless of that
> > if, in both of these functions the efs variable would eventually be
> > added to the outgoing configuration request that is being built:
> > 
> > l2cap_add_conf_opt(&ptr, L2CAP_CONF_EFS, sizeof(efs), (unsigned long) &efs);
> > 
> > So by sending a configuration request, or response, that contains an
> > L2CAP_CONF_EFS element, but with an element length that is not
> > sizeof(efs) - the memcpy to the uninitialized efs variable can be
> > avoided, and the uninitialized variable would be returned to the
> > attacker (16 bytes).
> > 
> > This issue has been assigned CVE-2017-1000410
> > 
> > Cc: Marcel Holtmann <[email-masked]>
> > Cc: Gustavo Padovan <[email-masked]>
> > Cc: Johan Hedberg <[email-masked]>
> > Cc: stable <[email-masked]>
> > Signed-off-by: Ben Seri <[email-masked]>
> > Signed-off-by: Greg Kroah-Hartman <[email-masked]>
> > ---
> >  net/bluetooth/l2cap_core.c |   20 +++++++++++---------
> >  1 file changed, 11 insertions(+), 9 deletions(-)
> > 
> > Marcel, for some reason this patch never got applied, despite lots of
> > advance notice.  Please, someone queue it up as it resolves the above
> > very-well-reported issue.
> > 
> 
> This patch is still not upstream or in -next. Given that we (ChromeOS)
> are heavy Bluetooth users, I'll go ahead and apply it without waiting
> any longer. For my understanding and for tracking purposes, it would
> be useful to know why it is not being applied. Does anyone know ?

I have no idea what is going on here, I'm going to throw it in my
char-misc tree now, this really isn't acceptable at all.

greg k-h